/*
  LinEAK - Linux support for Easy Access and Internet Keyboards      
  Copyright (C) 2001,2002 Mark Smulders <Mark@PIRnet.nl>
  
  lineakconfig, GTK+ interface for configuring lineakd

  This program is free software; you can redistribute it and/or modify  
  it under the terms of the GNU General Public License as published by  
  the Free Software Foundation; either version 2, or (at your option)   
  any later version.                                                    
                                                                        
  This program is distributed in the hope that it will be useful,       
  but WITHOUT ANY WARRANTY; without even the implied warranty of        
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         
  GNU General Public License for more details.                          
                                                                        
  You should have received a copy of the GNU General Public License     
  along with this program; if not, write to the                         
  Free Software Foundation, Inc., 59 Temple Place - Suite 330,          
  Boston, MA 02111-1307, USA.                                           
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacksproto.h"
#include "interface.h"
#include "support.h"

#include "pixmaps.h"

//#include <dmalloc.h>

/**********************************************************************************************/

/* create the main window */
GtkWidget* create_MainWindow (void) {
  GtkWidget *MainWindow;
  GtkWidget *fixed1;
  GtkWidget *frame1;
  GtkWidget *fixed2;
  GtkWidget *kbbrand;
  GtkWidget *kbbrand_menu;
  GtkWidget *kbmodel;
  GtkWidget *kbmodel_menu;
  GtkWidget *cdromentry;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *label3;
  GtkWidget *label4;
  GtkWidget *mixerentry;
  GtkWidget *kbimage;
  GtkWidget *frame2;
  GtkWidget *fixed3;
  GtkWidget *scrolledwindow1;
  GtkWidget *viewport1;
  GtkWidget *keylist;
  GtkWidget *commandentry;
  GtkWidget *specials;
  GtkWidget *specials_menu;
//  GtkWidget *presets;
//  GtkWidget *presets_menu;
//  GtkWidget *setsave_button;
//  GtkWidget *setdel_button;
  GtkWidget *label5;
//  GtkWidget *label16;
  GSList *KeyActionGroup_group = NULL;
  GtkWidget *radiocommand;
  GtkWidget *radiospecial;
  GtkWidget *frame3;
  GtkWidget *fixed4;
  GtkWidget *button1;
  GtkWidget *hbox1;
  GtkWidget *label6;
  GtkWidget *pixmap1;
  GtkWidget *label7;
  GtkWidget *label8;
  GtkWidget *button2;
  GtkWidget *hbox2;
  GtkWidget *label9;
  GtkWidget *pixmap3;
  GtkWidget *label10;
  GtkWidget *label11;
  GtkWidget *button3;
  GtkWidget *hbox3;
  GtkWidget *label12;
  GtkWidget *pixmap4;
  GtkWidget *label13;
  GtkWidget *label14;
  GtkWidget *pixmaplogo;

  MainWindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (MainWindow), "MainWindow", MainWindow);
  gtk_container_set_border_width (GTK_CONTAINER (MainWindow), 2);
  gtk_window_set_title (GTK_WINDOW (MainWindow), _("LinEAK Configuration"));
  gtk_window_set_position (GTK_WINDOW (MainWindow), GTK_WIN_POS_CENTER);
  gtk_window_set_default_size (GTK_WINDOW (MainWindow), 300, 600);
  gtk_window_set_policy (GTK_WINDOW (MainWindow), FALSE, FALSE, FALSE);

  fixed1 = gtk_fixed_new ();
  gtk_widget_ref (fixed1);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "fixed1", fixed1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed1);
  gtk_container_add (GTK_CONTAINER (MainWindow), fixed1);


/* lineak logo */
  pixmaplogo = create_my_pixmap_from_file (MainWindow, "lineak_logo.xpm");
  gtk_widget_ref (pixmaplogo);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "pixmaplogo", pixmaplogo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmaplogo);
  gtk_fixed_put (GTK_FIXED (fixed1), pixmaplogo, 4, 4);
  gtk_widget_set_uposition (pixmaplogo, 4, 4);


/* global settings */
  frame1 = gtk_frame_new (_("Global settings"));
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_fixed_put (GTK_FIXED (fixed1), frame1, 0, 100);
  gtk_widget_set_uposition (frame1, 0, 100);
  gtk_widget_set_usize (frame1, 432, 187);

  fixed2 = gtk_fixed_new ();
  gtk_widget_ref (fixed2);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "fixed2", fixed2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed2);
  gtk_container_add (GTK_CONTAINER (frame1), fixed2);
  

  /* kbtypes: label */
  label1 = gtk_label_new (_("Keyboard brand:"));
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_fixed_put (GTK_FIXED (fixed2), label1, 16, 0);
  gtk_widget_set_uposition (label1, 16, 0);
  gtk_widget_set_usize (label1, 96, 24);

  label2 = gtk_label_new (_("Keyboard model:"));
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_fixed_put (GTK_FIXED (fixed2), label2, 192, 0);
  gtk_widget_set_uposition (label2, 192, 0);
  gtk_widget_set_usize (label2, 96, 24);


  /* kbtypes: option menu */
  kbbrand = gtk_option_menu_new ();
  gtk_widget_ref (kbbrand);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "kbbrand", kbbrand,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (kbbrand);
  gtk_fixed_put (GTK_FIXED (fixed2), kbbrand, 16, 24);
  gtk_widget_set_uposition (kbbrand, 16, 24);
  gtk_widget_set_usize (kbbrand, 144, 24);
  kbbrand_menu = gtk_menu_new ();
  gtk_option_menu_set_menu (GTK_OPTION_MENU (kbbrand), kbbrand_menu);

  kbmodel = gtk_option_menu_new ();
  gtk_widget_ref (kbmodel);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "kbmodel", kbmodel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (kbmodel);
  gtk_fixed_put (GTK_FIXED (fixed2), kbmodel, 192, 24);
  gtk_widget_set_uposition (kbmodel, 192, 24);
  gtk_widget_set_usize (kbmodel, 216, 24);
  kbmodel_menu = gtk_menu_new ();
  gtk_option_menu_set_menu (GTK_OPTION_MENU (kbmodel), kbmodel_menu);

  /* cdrom: label */
  label3 = gtk_label_new (_("CD-ROM device:"));
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_fixed_put (GTK_FIXED (fixed2), label3, 16, 56);
  gtk_widget_set_uposition (label3, 16, 56);
  gtk_widget_set_usize (label3, 96, 24);

  label4 = gtk_label_new (_("Mixer device:"));
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_fixed_put (GTK_FIXED (fixed2), label4, 16, 112);
  gtk_widget_set_uposition (label4, 16, 112);
  gtk_widget_set_usize (label4, 80, 24);

  /* cdrom: entry */
  cdromentry = gtk_entry_new ();
  gtk_widget_ref (cdromentry);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "cdromentry", cdromentry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cdromentry);
  gtk_fixed_put (GTK_FIXED (fixed2), cdromentry, 16, 80);
  gtk_widget_set_uposition (cdromentry, 16, 80);
  gtk_widget_set_usize (cdromentry, 144, 22);

  mixerentry = gtk_entry_new ();
  gtk_widget_ref (mixerentry);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "mixerentry", mixerentry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mixerentry);
  gtk_fixed_put (GTK_FIXED (fixed2), mixerentry, 16, 136);
  gtk_widget_set_uposition (mixerentry, 16, 136);
  gtk_widget_set_usize (mixerentry, 144, 22);

  /* keyboard image... dynamically created at runtime */
  kbimage = create_my_pixmap (MainWindow, dummy_pixmap_xpm);
  gtk_widget_ref (kbimage);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "kbimage", kbimage,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (kbimage);
  gtk_fixed_put (GTK_FIXED (fixed2), kbimage, 192, 76);
  gtk_widget_set_uposition (kbimage, 192, 76);


/* keyboard settings */
  frame2 = gtk_frame_new (_("Keyboard settings"));
  gtk_widget_ref (frame2);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "frame2", frame2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame2);
  gtk_fixed_put (GTK_FIXED (fixed1), frame2, 0, 295);
  gtk_widget_set_uposition (frame2, 0, 295);
  gtk_widget_set_usize (frame2, 432, 240);

  fixed3 = gtk_fixed_new ();
  gtk_widget_ref (fixed3);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "fixed3", fixed3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed3);
  gtk_container_add (GTK_CONTAINER (frame2), fixed3);

  /* available keys */
  label5 = gtk_label_new (_("Available keys:"));
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_fixed_put (GTK_FIXED (fixed3), label5, 16, 8);
  gtk_widget_set_uposition (label5, 16, 8);
  gtk_widget_set_usize (label5, 88, 24);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_fixed_put (GTK_FIXED (fixed3), scrolledwindow1, 16, 32);
  gtk_widget_set_uposition (scrolledwindow1, 16, 32);
  gtk_widget_set_usize (scrolledwindow1, 152, 176);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_widget_ref (viewport1);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "viewport1", viewport1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (viewport1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport1);

  keylist = gtk_list_new ();
  gtk_widget_ref (keylist);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "keylist", keylist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (keylist);
  gtk_container_add (GTK_CONTAINER (viewport1), keylist);

  /* predefined command sets */
/*  label16 = gtk_label_new (_("Predefined command set:"));
  gtk_widget_ref (label16);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "label16", label16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label16);
  gtk_fixed_put (GTK_FIXED (fixed3), label16, 192, 8);
  gtk_widget_set_uposition (label16, 192, 8);
  gtk_widget_set_usize (label16, 144, 24);

  presets = gtk_option_menu_new ();
  gtk_widget_ref (presets);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "presets", presets,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (presets);
  gtk_fixed_put (GTK_FIXED (fixed3), presets, 192, 32);
  gtk_widget_set_uposition (presets, 192, 32);
  gtk_widget_set_usize (presets, 216, 24);
  presets_menu = gtk_menu_new ();
  gtk_option_menu_set_menu (GTK_OPTION_MENU (presets), presets_menu);

  setsave_button = gtk_button_new_with_label (_("Save set as..."));
  gtk_widget_ref (setsave_button);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "setsave_button", setsave_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (setsave_button);
  gtk_fixed_put (GTK_FIXED (fixed3), setsave_button, 192, 64);
  gtk_widget_set_uposition (setsave_button, 192, 64);
  gtk_widget_set_usize (setsave_button, 96, 24);

  setdel_button = gtk_button_new_with_label (_("Delete this set"));
  gtk_widget_ref (setdel_button);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "setdel_button", setdel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (setdel_button);
  gtk_fixed_put (GTK_FIXED (fixed3), setdel_button, 312, 64);
  gtk_widget_set_uposition (setdel_button, 312, 64);
  gtk_widget_set_usize (setdel_button, 96, 24); */
  
  /* run command */
  radiocommand = gtk_radio_button_new_with_label (KeyActionGroup_group, _("Key runs command:"));
  KeyActionGroup_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiocommand));
  gtk_widget_ref (radiocommand);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "radiocommand", radiocommand,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiocommand);
  gtk_fixed_put (GTK_FIXED (fixed3), radiocommand, 192, 40);
  gtk_widget_set_uposition (radiocommand, 192, /*104*/40);
  gtk_widget_set_usize (radiocommand, 136, 24);

  commandentry = gtk_entry_new ();
  gtk_widget_ref (commandentry);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "commandentry", commandentry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (commandentry);
  gtk_fixed_put (GTK_FIXED (fixed3), commandentry, 208, 64);
  gtk_widget_set_uposition (commandentry, 208, /*128*/64);
  gtk_widget_set_usize (commandentry, 200, 22);

  /* special action */
  radiospecial = gtk_radio_button_new_with_label (KeyActionGroup_group, _("Key performs special action:"));
  KeyActionGroup_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiospecial));
  gtk_widget_ref (radiospecial);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "radiospecial", radiospecial,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiospecial);
  gtk_fixed_put (GTK_FIXED (fixed3), radiospecial, 192, 128);
  gtk_widget_set_uposition (radiospecial, 192, /*160*/128);
  gtk_widget_set_usize (radiospecial, 184, 24);

  specials = gtk_option_menu_new ();
  gtk_widget_ref (specials);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "specials", specials,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (specials);
  gtk_fixed_put (GTK_FIXED (fixed3), specials, 208, 152);
  gtk_widget_set_uposition (specials, 208, /*184*/152);
  gtk_widget_set_usize (specials, 200, 24);
  specials_menu = gtk_menu_new ();
  gtk_option_menu_set_menu (GTK_OPTION_MENU (specials), specials_menu);

/* buttons */
  frame3 = gtk_frame_new (NULL);
  gtk_widget_ref (frame3);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "frame3", frame3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame3);
  gtk_fixed_put (GTK_FIXED (fixed1), frame3, 0, 543);
  gtk_widget_set_uposition (frame3, 0, 543);
  gtk_widget_set_usize (frame3, 432, 48);
  gtk_frame_set_shadow_type (GTK_FRAME (frame3), GTK_SHADOW_NONE);

  fixed4 = gtk_fixed_new ();
  gtk_widget_ref (fixed4);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "fixed4", fixed4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed4);
  gtk_container_add (GTK_CONTAINER (frame3), fixed4);

  /* OK */
  button1 = gtk_button_new ();
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  gtk_fixed_put (GTK_FIXED (fixed4), button1, 128, 0);
  gtk_widget_set_uposition (button1, 128, 0);
  gtk_widget_set_usize (button1, 88, 40);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (button1), hbox1);

  label6 = gtk_label_new (_("    "));
  gtk_widget_ref (label6);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "label6", label6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label6);
  gtk_box_pack_start (GTK_BOX (hbox1), label6, FALSE, FALSE, 0);

  pixmap1 = create_my_pixmap (MainWindow, ok_pixmap_xpm);
  gtk_widget_ref (pixmap1);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "pixmap1", pixmap1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap1);
  gtk_box_pack_start (GTK_BOX (hbox1), pixmap1, TRUE, TRUE, 0);

  label7 = gtk_label_new (_("OK"));
  gtk_widget_ref (label7);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "label7", label7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label7);
  gtk_box_pack_start (GTK_BOX (hbox1), label7, FALSE, FALSE, 0);

  label8 = gtk_label_new (_("     "));
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "label8", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_box_pack_start (GTK_BOX (hbox1), label8, FALSE, FALSE, 0);

  /* Apply */
  button2 = gtk_button_new ();
  gtk_widget_ref (button2);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "button2", button2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button2);
  gtk_fixed_put (GTK_FIXED (fixed4), button2, 232, 0);
  gtk_widget_set_uposition (button2, 232, 0);
  gtk_widget_set_usize (button2, 88, 40);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_container_add (GTK_CONTAINER (button2), hbox2);

  label9 = gtk_label_new (_("  "));
  gtk_widget_ref (label9);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "label9", label9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label9);
  gtk_box_pack_start (GTK_BOX (hbox2), label9, FALSE, FALSE, 0);

  pixmap3 = create_my_pixmap (MainWindow, apply_pixmap_xpm);
  gtk_widget_ref (pixmap3);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "pixmap3", pixmap3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap3);
  gtk_box_pack_start (GTK_BOX (hbox2), pixmap3, TRUE, TRUE, 0);

  label10 = gtk_label_new (_("Apply"));
  gtk_widget_ref (label10);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "label10", label10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label10);
  gtk_box_pack_start (GTK_BOX (hbox2), label10, FALSE, FALSE, 0);

  label11 = gtk_label_new (_("    "));
  gtk_widget_ref (label11);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "label11", label11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label11);
  gtk_box_pack_start (GTK_BOX (hbox2), label11, FALSE, FALSE, 0);

  /* Cancel */
  button3 = gtk_button_new ();
  gtk_widget_ref (button3);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "button3", button3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button3);
  gtk_fixed_put (GTK_FIXED (fixed4), button3, 336, 0);
  gtk_widget_set_uposition (button3, 336, 0);
  gtk_widget_set_usize (button3, 88, 40);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_container_add (GTK_CONTAINER (button3), hbox3);

  label12 = gtk_label_new (_("  "));
  gtk_widget_ref (label12);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "label12", label12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label12);
  gtk_box_pack_start (GTK_BOX (hbox3), label12, FALSE, FALSE, 0);

  pixmap4 = create_my_pixmap (MainWindow, cancel_pixmap_xpm);
  gtk_widget_ref (pixmap4);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "pixmap4", pixmap4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap4);
  gtk_box_pack_start (GTK_BOX (hbox3), pixmap4, TRUE, TRUE, 0);

  label13 = gtk_label_new (_("Cancel"));
  gtk_widget_ref (label13);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "label13", label13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label13);
  gtk_box_pack_start (GTK_BOX (hbox3), label13, FALSE, FALSE, 0);

  label14 = gtk_label_new (_("   "));
  gtk_widget_ref (label14);
  gtk_object_set_data_full (GTK_OBJECT (MainWindow), "label14", label14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label14);
  gtk_box_pack_start (GTK_BOX (hbox3), label14, FALSE, FALSE, 0);

/* signal handlers */
  gtk_signal_connect (GTK_OBJECT (MainWindow), "delete_event",
                      GTK_SIGNAL_FUNC (on_cancelbutton_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (cdromentry), "changed",
                      GTK_SIGNAL_FUNC (on_cdromentry_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mixerentry), "changed",
                      GTK_SIGNAL_FUNC (on_mixerentry_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (commandentry), "changed",
                      GTK_SIGNAL_FUNC (on_commandentry_changed),
                      NULL);
//  gtk_signal_connect (GTK_OBJECT (setsave_button), "clicked",
//                      GTK_SIGNAL_FUNC (on_setsave_button_clicked),
//                      NULL);
//  gtk_signal_connect (GTK_OBJECT (setdel_button), "clicked",
//                      GTK_SIGNAL_FUNC (on_setdel_button_clicked),
//                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiocommand), "toggled",
                      GTK_SIGNAL_FUNC (on_commandradio_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiospecial), "toggled",
                      GTK_SIGNAL_FUNC (on_actionradio_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button1), "clicked",
                      GTK_SIGNAL_FUNC (on_okbutton_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button2), "clicked",
                      GTK_SIGNAL_FUNC (on_applybutton_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button3), "clicked",
                      GTK_SIGNAL_FUNC (on_cancelbutton_clicked),
                      NULL);

  return MainWindow;
}

/**********************************************************************************************/

GtkWidget *create_warning_window (gchar *warntext) {
  GtkWidget *warning_window;
  GtkWidget *fixed1;
  GtkWidget *pixmap1;
  GtkWidget *error_label;
  GtkWidget *alert_close_button;

  warning_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (warning_window), "warning_window", warning_window);
  gtk_window_set_title (GTK_WINDOW (warning_window), "LinEAK ALERT");
  gtk_container_set_border_width (GTK_CONTAINER (warning_window), 5);
  gtk_window_set_position (GTK_WINDOW (warning_window), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (warning_window), TRUE);
  gtk_window_set_policy (GTK_WINDOW (warning_window), FALSE, FALSE, FALSE);

  fixed1 = gtk_fixed_new ();
  gtk_widget_ref (fixed1);
  gtk_object_set_data_full (GTK_OBJECT (warning_window), "fixed1", fixed1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed1);
  gtk_container_add (GTK_CONTAINER (warning_window), fixed1);

  pixmap1 = create_my_pixmap_from_file (warning_window, "warning.xpm");
  gtk_widget_ref (pixmap1);
  gtk_object_set_data_full (GTK_OBJECT (warning_window), "pixmap1", pixmap1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap1);
  gtk_fixed_put (GTK_FIXED (fixed1), pixmap1, 0, 0);

  alert_close_button = gtk_button_new_with_label ("Close");
  gtk_widget_ref (alert_close_button);
  gtk_object_set_data_full (GTK_OBJECT (warning_window), "alert_close_button", alert_close_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_signal_connect (GTK_OBJECT (alert_close_button), "clicked", GTK_SIGNAL_FUNC (on_alert_closebutton_clicked), NULL);
  gtk_widget_show (alert_close_button);
  gtk_fixed_put (GTK_FIXED (fixed1), alert_close_button, 112, 80);
  gtk_widget_set_uposition (alert_close_button, 112, 80);
  gtk_widget_set_usize (alert_close_button, 72, 30);

  error_label = gtk_label_new (warntext);
  gtk_widget_ref (error_label);
  gtk_object_set_data_full (GTK_OBJECT (warning_window), "error_label", error_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (error_label);
  gtk_fixed_put (GTK_FIXED (fixed1), error_label, 56, 0);
  gtk_widget_set_uposition (error_label, 56, 0);
  gtk_widget_set_usize (error_label, 240, 80);
  gtk_label_set_justify (GTK_LABEL (error_label), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (error_label), TRUE);

  return warning_window;
}

/**********************************************************************************************/

GtkWidget*
create_NewConfWindow (gchar *Xtratext)
{
  GtkWidget *NewConfWindow;
  GtkWidget *fixed6;
  GtkWidget *NCsaveconfbutton;
  GtkWidget *NCcancelbutton;
  GtkWidget *frame4;
  GtkWidget *fixed7;
  GtkWidget *label21;
  GtkWidget *label22;
  GtkWidget *kbbrand;
  GtkWidget *kbbrand_menu;
  GtkWidget *kbmodel;
  GtkWidget *kbmodel_menu;
  GtkWidget *label20;
  GtkWidget *label23;
  GtkWidget *label24;
  GtkWidget *label25;
  GtkWidget *NCcdromentry;
  GtkWidget *NCmixerentry;
  GtkWidget *XtraText;

  NewConfWindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (NewConfWindow), "NewConfWindow", NewConfWindow);
  gtk_container_set_border_width (GTK_CONTAINER (NewConfWindow), 2);
  gtk_window_set_title (GTK_WINDOW (NewConfWindow), _("New LinEAK Keyboard Configuration"));
  gtk_window_set_position (GTK_WINDOW (NewConfWindow), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (NewConfWindow), FALSE, FALSE, FALSE);

  fixed6 = gtk_fixed_new ();
  gtk_widget_ref (fixed6);
  gtk_object_set_data_full (GTK_OBJECT (NewConfWindow), "fixed6", fixed6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed6);
  gtk_container_add (GTK_CONTAINER (NewConfWindow), fixed6);

  NCsaveconfbutton = gtk_button_new_with_label (_("Create this configuration"));
  gtk_widget_ref (NCsaveconfbutton);
  gtk_object_set_data_full (GTK_OBJECT (NewConfWindow), "NCsaveconfbutton", NCsaveconfbutton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (NCsaveconfbutton);
  gtk_fixed_put (GTK_FIXED (fixed6), NCsaveconfbutton, 296, 224);
  gtk_widget_set_uposition (NCsaveconfbutton, 296, 224);
  gtk_widget_set_usize (NCsaveconfbutton, 144, 40);

  NCcancelbutton = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_ref (NCcancelbutton);
  gtk_object_set_data_full (GTK_OBJECT (NewConfWindow), "NCcancelbutton", NCcancelbutton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (NCcancelbutton);
  gtk_fixed_put (GTK_FIXED (fixed6), NCcancelbutton, 456, 224);
  gtk_widget_set_uposition (NCcancelbutton, 456, 224);
  gtk_widget_set_usize (NCcancelbutton, 71, 40);

  frame4 = gtk_frame_new (NULL);
  gtk_widget_ref (frame4);
  gtk_object_set_data_full (GTK_OBJECT (NewConfWindow), "frame4", frame4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame4);
  gtk_fixed_put (GTK_FIXED (fixed6), frame4, 0, 24);
  gtk_widget_set_uposition (frame4, 0, 24);
  gtk_widget_set_usize (frame4, 536, 192);

  fixed7 = gtk_fixed_new ();
  gtk_widget_ref (fixed7);
  gtk_object_set_data_full (GTK_OBJECT (NewConfWindow), "fixed7", fixed7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed7);
  gtk_container_add (GTK_CONTAINER (frame4), fixed7);

  label21 = gtk_label_new (_("Brand:"));
  gtk_widget_ref (label21);
  gtk_object_set_data_full (GTK_OBJECT (NewConfWindow), "label21", label21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label21);
  gtk_fixed_put (GTK_FIXED (fixed7), label21, 24, 32);
  gtk_widget_set_uposition (label21, 24, 32);
  gtk_widget_set_usize (label21, 41, 16);

  label22 = gtk_label_new (_("Model:"));
  gtk_widget_ref (label22);
  gtk_object_set_data_full (GTK_OBJECT (NewConfWindow), "label22", label22,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label22);
  gtk_fixed_put (GTK_FIXED (fixed7), label22, 192, 32);
  gtk_widget_set_uposition (label22, 192, 32);
  gtk_widget_set_usize (label22, 41, 16);

  kbbrand = gtk_option_menu_new ();
  gtk_widget_ref (kbbrand);
  gtk_object_set_data_full (GTK_OBJECT (NewConfWindow), "kbbrand", kbbrand,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (kbbrand);
  gtk_fixed_put (GTK_FIXED (fixed7), kbbrand, 32, 48);
  gtk_widget_set_uposition (kbbrand, 32, 48);
  gtk_widget_set_usize (kbbrand, 152, 24);
  kbbrand_menu = gtk_menu_new ();
  gtk_option_menu_set_menu (GTK_OPTION_MENU (kbbrand), kbbrand_menu);

  kbmodel = gtk_option_menu_new ();
  gtk_widget_ref (kbmodel);
  gtk_object_set_data_full (GTK_OBJECT (NewConfWindow), "kbmodel", kbmodel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (kbmodel);
  gtk_fixed_put (GTK_FIXED (fixed7), kbmodel, 200, 48);
  gtk_widget_set_uposition (kbmodel, 200, 48);
  gtk_widget_set_usize (kbmodel, 296, 24);
  kbmodel_menu = gtk_menu_new ();
  gtk_option_menu_set_menu (GTK_OPTION_MENU (kbmodel), kbmodel_menu);

  label20 = gtk_label_new (_("Select your keyboard"));
  gtk_widget_ref (label20);
  gtk_object_set_data_full (GTK_OBJECT (NewConfWindow), "label20", label20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label20);
  gtk_fixed_put (GTK_FIXED (fixed7), label20, 8, 8);
  gtk_widget_set_uposition (label20, 8, 8);
  gtk_widget_set_usize (label20, 128, 16);

  label23 = gtk_label_new (_("Set device options"));
  gtk_widget_ref (label23);
  gtk_object_set_data_full (GTK_OBJECT (NewConfWindow), "label23", label23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label23);
  gtk_fixed_put (GTK_FIXED (fixed7), label23, 8, 96);
  gtk_widget_set_uposition (label23, 8, 96);
  gtk_widget_set_usize (label23, 112, 16);

  label24 = gtk_label_new (_("CD-ROM device:"));
  gtk_widget_ref (label24);
  gtk_object_set_data_full (GTK_OBJECT (NewConfWindow), "label24", label24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label24);
  gtk_fixed_put (GTK_FIXED (fixed7), label24, 24, 120);
  gtk_widget_set_uposition (label24, 24, 120);
  gtk_widget_set_usize (label24, 104, 16);

  label25 = gtk_label_new (_("Mixer device:"));
  gtk_widget_ref (label25);
  gtk_object_set_data_full (GTK_OBJECT (NewConfWindow), "label25", label25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label25);
  gtk_fixed_put (GTK_FIXED (fixed7), label25, 192, 120);
  gtk_widget_set_uposition (label25, 192, 120);
  gtk_widget_set_usize (label25, 88, 16);

  NCcdromentry = gtk_entry_new ();
  gtk_widget_ref (NCcdromentry);
  gtk_object_set_data_full (GTK_OBJECT (NewConfWindow), "NCcdromentry", NCcdromentry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (NCcdromentry);
  gtk_fixed_put (GTK_FIXED (fixed7), NCcdromentry, 32, 136);
  gtk_widget_set_uposition (NCcdromentry, 32, 136);
  gtk_widget_set_usize (NCcdromentry, 152, 24);

  NCmixerentry = gtk_entry_new ();
  gtk_widget_ref (NCmixerentry);
  gtk_object_set_data_full (GTK_OBJECT (NewConfWindow), "NCmixerentry", NCmixerentry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (NCmixerentry);
  gtk_fixed_put (GTK_FIXED (fixed7), NCmixerentry, 200, 136);
  gtk_widget_set_uposition (NCmixerentry, 200, 136);
  gtk_widget_set_usize (NCmixerentry, 152, 22);

  XtraText = gtk_label_new (Xtratext);
  gtk_widget_ref (XtraText);
  gtk_object_set_data_full (GTK_OBJECT (NewConfWindow), "XtraText", XtraText,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (XtraText);
  gtk_fixed_put (GTK_FIXED (fixed6), XtraText, 8, 8);
  gtk_widget_set_uposition (XtraText, 8, 8);
  gtk_widget_set_usize (XtraText, 520, 16);

  gtk_signal_connect (GTK_OBJECT (NewConfWindow), "delete_event",
                      GTK_SIGNAL_FUNC (on_NCwin_close),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (NCcdromentry), "changed",
                      GTK_SIGNAL_FUNC (on_cdromentry_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (NCmixerentry), "changed",
                      GTK_SIGNAL_FUNC (on_mixerentry_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (NCsaveconfbutton), "clicked",
                      GTK_SIGNAL_FUNC (on_NCsaveconfbutton_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (NCcancelbutton), "clicked",
                      GTK_SIGNAL_FUNC (on_NCwin_close),
                      NULL);

  return NewConfWindow;
}

/**********************************************************************************************/
