/*
  LinEAK - Linux support for Easy Access and Internet Keyboards      
  Copyright (C) 2001,2002 Mark Smulders <Mark@PIRnet.nl>
  
  lineakconfig, GTK+ interface for configuring lineakd

  This program is free software; you can redistribute it and/or modify  
  it under the terms of the GNU General Public License as published by  
  the Free Software Foundation; either version 2, or (at your option)   
  any later version.                                                    
                                                                        
  This program is distributed in the hope that it will be useful,       
  but WITHOUT ANY WARRANTY; without even the implied warranty of        
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         
  GNU General Public License for more details.                          
                                                                        
  You should have received a copy of the GNU General Public License     
  along with this program; if not, write to the                         
  Free Software Foundation, Inc., 59 Temple Place - Suite 330,          
  Boston, MA 02111-1307, USA.                                           
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"


/**********************************************************************************************/

/* main function */
int main (int argc, char *argv[]) {
  GtkWidget *MainWindow;
  extern gboolean ApplyUsed, inNCwindow;

#ifdef ENABLE_NLS
  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain (PACKAGE);
#endif

  /* gtk init */
  gtk_set_locale ();
  gtk_init (&argc, &argv);
  
  /* parse .conf and .def files, and init the EAK data */
  inNCwindow = FALSE;
  FirstTimeBrand=TRUE; FirstTimeModel=TRUE;
  kbtype=NULL; cdromdev=NULL; mixdev=NULL; usrdefdata=NULL;
  if (!parsedeffile() || !parseconffile())
	exit(0);
  if (!initEAK()) {
	cleanKeylist();
	exit(0);
  }

  /* create, fill, show  the interface */
  MainWindow = create_MainWindow ();
  refreshGUIdata(MainWindow);
  gtk_widget_show (MainWindow);

  ApplyUsed = FALSE;
  gtk_main ();
  return 0;
}

/**********************************************************************************************/

