/*
  LinEAK - Linux support for Easy Access and Internet Keyboards      
  Copyright (C) 2001,2002 Mark Smulders <Mark@PIRnet.nl>
  
  lineak-config, GTK+ interface for configuring lineakd

  This program is free software; you can redistribute it and/or modify  
  it under the terms of the GNU General Public License as published by  
  the Free Software Foundation; either version 2, or (at your option)   
  any later version.                                                    
                                                                        
  This program is distributed in the hope that it will be useful,       
  but WITHOUT ANY WARRANTY; without even the implied warranty of        
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         
  GNU General Public License for more details.                          
                                                                        
  You should have received a copy of the GNU General Public License     
  along with this program; if not, write to the                         
  Free Software Foundation, Inc., 59 Temple Place - Suite 330,          
  Boston, MA 02111-1307, USA.                                           
*/

/**********************************************************************************************/
/* Below are the pixmaps used for the OK, Apply and Cancel buttons
   I could have used the GTK_STOCK buttons, but linking several gnome libraries for just a
   few buttons seemed like overhead to me.
   Furthermore, I want this to be a GTK+ program, not Gnome specific ;-)                      */

/* OK */
static char *ok_pixmap_xpm[] = {
  /* columns rows colors chars-per-pixel */
  "20 20 47 1",
  /* color definitions */
  " 	c None",
  ".	c #10120F",
  "+	c #000000",
  "@	c #B6C6AA",
  "#	c #ADBBA1",
  "$	c #9EAB93",
  "%	c #95A28B",
  "&	c #D5E7C7",
  "*	c #9CA992",
  "=	c #7E8875",
  "-	c #94A08A",
  ";	c #7B8572",
  ">	c #636B5C",
  ",	c #838E7A",
  "'	c #616A5B",
  ")	c #707A69",
  "!	c #AAB89E",
  "~	c #575E51",
  "{	c #585F52",
  "]	c #687161",
  "^	c #798371",
  "/	c #97A48D",
  "(	c #B2C1A6",
  "_	c #99A68E",
  ":	c #727C6A",
  "<	c #42483E",
  "[	c #8A9580",
  "}	c #606859",
  "|	c #41473D",
  "1	c #818C79",
  "2	c #5B6255",
  "3	c #40453C",
  "4	c #4E5549",
  "5	c #909C87",
  "6	c #7C8774",
  "7	c #555D50",
  "8	c #3E4339",
  "9	c #929E88",
  "0	c #52594C",
  "a	c #393E35",
  "b	c #4C5247",
  "c	c #8F9B85",
  "d	c #6A7363",
  "e	c #4F564A",
  "f	c #51574B",
  "g	c #0E0F0D",
  "h	c #383C34",
  /* the pixels */
  "                    ",
  "           .......  ",
  "          +@@@#$$%. ",
  "          .@&*%%%=. ",
  "          .@@%%%%=. ",
  "          .@%%-%%=. ",
  "      .   .@%$%%%=. ",
  "     .;.  .@%%%%%=. ",
  "    .@>....@%%%,'). ",
  "   .@!;~~~{'>]^/({. ",
  "  .@/%%%%////_%:<.  ",
  " .@_%%%%%%%%%[}|.   ",
  ".@*/%%%%%%%%123.    ",
  " .45%%%%%%%678.     ",
  "  .49%%%%-60a.      ",
  "   .b5c6;dea.       ",
  "    .feg....        ",
  "     .h.            ",
  "      .             ",
  "                    "
};


/* Apply */
static char *apply_pixmap_xpm[] = {
  /* columns rows colors chars-per-pixel */
  "20 20 18 1",
  /* color definitions */
  " 	c None",
  ".	c #000000",
  "+	c #B3C2A7",
  "@	c #708C58",
  "#	c #859D71",
  "$	c #627B4D",
  "%	c #97AB86",
  "&	c #566C43",
  "*	c #A2BD9E",
  "=	c #789774",
  "-	c #88AC84",
  ";	c #5E764A",
  ">	c #698566",
  ",	c #6D8855",
  "'	c #688251",
  ")	c #668050",
  "!	c #6D8956",
  "~	c #4F633E",
  /* the pixels */
  "                    ",
  "                    ",
  "                    ",
  "             ..     ",
  "            .+@.    ",
  "            .#$.    ",
  "           .%@.     ",
  "     ..    .#&.     ",
  "    .*=.  .#@.      ",
  "    .--.. .@&.      ",
  "     .-=..;@.       ",
  "     .-->.,&.       ",
  "      .--').        ",
  "       .-!~.        ",
  "       .--.         ",
  "        .>.         ",
  "         .          ",
  "                    ",
  "                    ",
  "                    "
};


/* Cancel */
static char *cancel_pixmap_xpm[] = {
  /* columns rows colors chars-per-pixel */
  "20 20 8 1",
  /* color definitions */
  " 	c None",
  ".	c #000000",
  "+	c #C46D74",
  "@	c #9F3C44",
  "#	c #B5444E",
  "$	c #BD5A62",
  "%	c #7B2D34",
  "&	c #8C343C",
  /* the pixels */
  "                    ",
  "                    ",
  "                    ",
  "      ..      .     ",
  "     .+@.    .#.    ",
  "     .##.   .$#.    ",
  "      .#@. .$#%.    ",
  "      .##..$#&.     ",
  "       .####@.      ",
  "       .####.       ",
  "      .$###.        ",
  "     .$####.        ",
  "    .$#&..#&.       ",
  "   .+#&. .@#.       ",
  "   .#&.   .#@.      ",
  "    ..    .@#.      ",
  "           ..       ",
  "                    ",
  "                    ",
  "                    "
};

/**********************************************************************************************/

/* This is a dummy pixmap we use when a pixmap can't be found. */
static char *dummy_pixmap_xpm[] = {
/* columns rows colors chars-per-pixel */
"1 1 1 1",
"  c None",
/* pixels */
" "
};

