/*
  LinEAK - Linux support for Easy Access and Internet Keyboards      
  Copyright (C) 2001,2002 Mark Smulders <Mark@PIRnet.nl>
  
  lineakconfig, GTK+ interface for configuring lineakd

  This program is free software; you can redistribute it and/or modify  
  it under the terms of the GNU General Public License as published by  
  the Free Software Foundation; either version 2, or (at your option)   
  any later version.                                                    
                                                                        
  This program is distributed in the hope that it will be useful,       
  but WITHOUT ANY WARRANTY; without even the implied warranty of        
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         
  GNU General Public License for more details.                          
                                                                        
  You should have received a copy of the GNU General Public License     
  along with this program; if not, write to the                         
  Free Software Foundation, Inc., 59 Temple Place - Suite 330,          
  Boston, MA 02111-1307, USA.                                           
*/

/**********************************************************************************************/

/* special actions in .conf file */
#define NR_SPECIALS 5
/* link them to strings */
#define EAK_EJECT "EAK_EJECT"
#define EAK_VOLUP "EAK_VOLUP"
#define EAK_VOLDOWN "EAK_VOLDOWN"
#define EAK_MUTE "EAK_MUTE"
#define EAK_SLEEP "EAK_SLEEP"
/* provides indexes etc of the actions for the gui ( 0 - (n-1) ) */
typedef struct {
  gchar *action;
  gchar *longname;
} specialact;
static specialact specialacts[NR_SPECIALS] = {
  {EAK_EJECT, "Eject CD-ROM"},
  {EAK_VOLUP, "Increase volume"},
  {EAK_VOLDOWN, "Decrease volume"},
  {EAK_MUTE, "Mute volume"},
  {EAK_SLEEP, "Sleep"}
};

gboolean ApplyUsed;
gboolean inNCwindow;

#define CONF_HEADER \
"# LinEAK - Linux support for Easy Access and Internet Keyboards\n" \
"#  Copyright (c) 2001,2002 Mark Smulders <Mark@PIRnet.nl>\n" \
"#  http://lineak.sourceforge.net\n" \
"#\n" \
"# lineakd configuration file\n" \
"#\n" \
"# example key configuration:\n" \
"# \tplay\t= \"xmms --play-pause\"\n" \
"# \teject\t= EAK_EJECT\n" \
"#\n" \
"# available special actions:\n" \
"# \tEAK_EJECT\n" \
"# \tEAK_VOLUP\n" \
"# \tEAK_VOLDOWN\n" \
"# \tEAK_MUTE\n" \
"# \tEAK_SLEEP\n" \
"#\n" \
"\n"
